<template>
  <div
    :data-qa="dataQa"
    :class="['logchain-card', showLabel ? 'logchain-card--label' : '']"
  >
    <div
      v-if="showLabel"
      class="logchain-card__label"
      :style="labelStyle"
    >
      <i :class="['icon', labelIcon]" />
      {{ labelText }}
    </div>
    <div v-if="logchain.main_data.logchainServiceName && logchain.main_data.logchainServiceName.length" class="logchain-card__container">
      <span>
        {{ logchain.main_data.logchainServiceCount }}X
      </span>
      {{ logchain.main_data.logchainServiceName }}
    </div>
    <div class="logchain-card__header">
      <div class="logchain-card__header-info">
        <div class="logchain-card__price">
          <template v-if="(!logchain.main_data.is_multistop && limitsTotalAll) || (logchain.main_data.is_multistop && limitsTotal > 0)">
            <ob-currency v-if="actualTariff && actualTariff.totalPrice" :value="actualTariff.totalPrice / 100" />
            <ob-currency v-else :value="logchain.main_data.total_price / 100" />
          </template>
          <template v-if="(!limitsTotalAll && !logchain.main_data.is_multistop) || (logchain.main_data.is_multistop && limitsTotal <= 0)">
            ? ₽
          </template>
          <template>
            <span v-if="limitsTotalAll || (logchain.main_data.is_multistop && limitsTotal > 0)">
              (без НДС)
            </span>
          </template>
        </div>
        <div class="logchain-card__dates">
          {{ topStartDate }} – {{ topEndDate }}
        </div>
        <div class="logchain-card__route-info">
          <i class="icon map" />
          {{ routeLength }} ≈ {{ routeDuration }}
        </div>
        <div class="logchain-card__contractor" v-if="logchain.main_data.executorName">
          Через:
          <i class="icon truck"></i>
          <span>
            {{ logchain.main_data.executorName }}
          </span>
        </div>
      </div>
      <div class="logchain-card__header-details">
        <div class="logchain-card__header-contract">
          <span>
            <template v-if="logchain.main_data.vat && logchain.main_data.vat > 0">
            НДС 
            <template v-if="actualTariff && actualTariff.totalPrice">
              {{ actualTariff.vatValue / 100 | currency({ dot: 2 }) }} ₽
            </template>
            <template v-else>
              {{ ((logchain.main_data.total_price / 100) * logchain.main_data.vat) / 100 | currency({ dot: 2 }) }} ₽
            </template>
          </template>
          <template v-else>
            НДС не облагается
          </template>
          </span>
          <span v-if="contractNumber">
            Внешний договор:
            <template v-if="logchain.main_data.tariff && logchain.main_data.tariff.contractUuid">
              <router-link :to="`/contract/${logchain.main_data.tariff.contractUuid}`">{{ contractNumber }}</router-link>
            </template>
            <template v-else>
              {{ contractNumber }}
            </template>
          </span>
        </div>
        <div class="loghain-card__header-vat">
          <span>
            <ob-tooltip position="top-start">
              <div slot="content">
                <div class="tooltip">До уточнения маршрута и услуг</div>
              </div>
              <i class="icon info"></i>
            </ob-tooltip>
            Себестоимость, без НДС:
          </span>
          <template v-if="logchain.main_data.is_multistop">
            <template v-if="limitsTotal">
              {{ limitsTotal | currency({ dot: 2 }) }} ₽
            </template>
            <template v-else>
              <span class="error">Не определена</span>
            </template>
          </template>
          <template v-else>
            <template v-if="limitsTotalAll">
              {{ limitsTotal | currency({ dot: 2 }) }} ₽
            </template>
            <template v-else>
              <span class="error">Не определена</span>
            </template>
          </template>
        </div>
        <div class="loghain-card__header-tariff">
          <span>
            <ob-tooltip position="top-start">
              <div slot="content">
                <div class="tooltip">До уточнения маршрута и услуг</div>
              </div>
              <i class="icon info"></i>
            </ob-tooltip>
            Маржа без НДС:
          </span> 
          <template v-if="limitsTotal">
            <template v-if="actualTariff && actualTariff.totalPrice">
              {{ (actualTariff.totalPrice / 100) - limitsTotal | currency({ dot: 2 }) }}
            </template>
            <template v-else>
              {{ (logchain.main_data.total_price / 100) - limitsTotal | currency({ dot: 2 }) }}
            </template>
          </template>
          <template v-else>
            ?₽
          </template>
          <span class="vat-percent">
            <template v-if="primeCost && primeCost.profitPercent">
              {{ primeCost.profitPercent }} %  
            </template>
            <template v-else>
              {{ Math.round((logchain.main_data.total_price / 100 - limitsTotal)  / limitsTotal * 100) }} %
            </template>
          </span>
        </div>
      </div>
    </div>
    <div class="logchain-card__content">
      <div class="logchain-card__line">
        <div class="start-icon">
          <i class="icon zagr" v-for="(count, index) in startPoint.visitPointFromCount" :key="index"><span class="path1"></span></i>
        </div>
        <div class="end-icon">
          <i class="icon razgr" v-for="(count, index) in endPoint.visitPointToCount" :key="index + 10"><span class="path1"></span></i>
        </div>
      </div>
      <div class="logchain-card__points">
        <div class="logchain-card__point logchain-card__point--start">
          <i :class="['icon', getLocationIconByCode(startPoint['location_type_code'])]" />
          {{ startPoint['location_title'] }}
          <span>{{ startDate }}</span>
        </div>
        <template v-if="inBetweenPoints && inBetweenPoints.length">
          <div
            v-for="point in inBetweenPoints"
            :key="point.uuid"
            class="logchain-card__point"
          >
            <div class="logchain-card__point-icons">
              <i class="icon zagr" v-for="(count, index) in point.visitPointFromCount" :key="index + 200"><span class="path1"></span></i>
              <i class="icon razgr" v-for="(count, index) in point.visitPointToCount" :key="index + 300"><span class="path1"></span></i>
            </div>
            <i :class="['icon', getLocationIconByCode(point['location_type_code'])]" />
            {{ point.location_title }}
          </div>
        </template>
        <div class="logchain-card__point logchain-card__point--end">
          <i :class="['icon', getLocationIconByCode(endPoint['location_type_code'])]" />
          {{ endPoint['location_title'] }}
          <span>{{ endDate }}</span>
        </div>
      </div>
      <div class="logchain-card__inbetween" v-if="servicePoints && servicePoints.length">
        <div
          class='logchain-card__inbetween-point'
          v-for="point in servicePoints"
          :key="point.uuid"
        >
          <div class="logchain-card__inbetween-point-info">
            <i
              :class="['icon', $options.logchainIconsMap[point.resource_class_uuid.toLowerCase()]]"
              v-if="!logchain.main_data.is_multistop || (logchain.main_data.is_multistop && point.ordinal === logchain.points.length)"
            ></i>
            <div
              class="logchain-card__inbetween-label"
              v-if="!logchain.main_data.is_multistop || (logchain.main_data.is_multistop && point.ordinal === logchain.points.length)">
              <template v-if="point.replaceableServices && point.replaceableServices.length > 1 && point.serviceUuid">
                <span class="count">
                  {{point.second_point__resource_count || point.resource_count}}x
                </span>
                <ob-inline-select
                  v-model="point.serviceUuid"
                  :items="getReplaceableServices(point.replaceableServices)"
                  :isGrouped="isGroupReplaceableServices(point.replaceableServices)"
                  valueExpr="logchainPointServiceUuid"
                  valueLabelExpr="selectedTitle"
                  groupDisplayExpr="groupTitle"
                  groupChildExpr="items"
                  popperClass="replaceablePopper"
                  :inheritWidth="false"
                  @input="onChangeService"
                >

                </ob-inline-select>
              </template>
              <template v-else>
                <span class="count">
                  {{point.second_point__resource_count || point.resource_count}}x
                </span>
                <span class="title">
                  {{point.second_point__resource_title || point.resource_title || '—'}}
                </span>
              </template> 
            </div>
            <div class="logchain-card__inbetween-vat">
              <div class="vat-parent">
                <template v-if="logchain.main_data.is_multistop">
                  <template v-if="inbetweenPointVat(point)">
                    <span title="Себестоимость плеча, без НДС">{{ inbetweenPointVat(point) | currency({ dot: 2 }) }} ₽</span>
                  </template>
                </template>
                <template v-else>
                  <template v-if="inbetweenPointVat(point)">
                    <span title="Себестоимость плеча, без НДС">{{ inbetweenPointVat(point) | currency({ dot: 2 }) }} ₽</span>
                  </template>
                  <template v-else>
                    <span class="error">
                      Себестоимость не определена
                    </span>
                  </template>
                </template>
              </div>
              <div class="vat-child" v-if="point.limits.length > 1">
                <template v-if="inbetweenPointVatChild(point)">
                  <span title="Провозной тариф, без НДС">{{ inbetweenPointVatChild(point) | currency({ dot: 2 }) }} ₽</span>
                </template>
                <template v-else>
                  <span class="error">
                    Себестоимость не определена
                  </span>
                </template>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="logchain-card__errors" v-if="logchain.errors">
      <div class="logchain-card__errors-icon">
        <i class="icon info"></i>
      </div>
      <div class="logchain-card__errors-text">
        Ошибка обмена данными с ЭТП ГП,
        <span @click.stop="showErrorsInfo">подробнее</span>
      </div>
    </div>
    <div v-if="logchain.main_data.has_additional_service" class="logchain-card__bottom-outer">
      <div class="logchain-card__info-message">
        В логцепочке есть дополнительные услуги
      </div>
    </div>
    <div v-if="logchainNumber" class="logchain-card__top-outer">
      <div class="logchain-card__info-message">
        {{ logchainNumber }}
      </div>
    </div>
  </div>
</template>

<script>
import { getLocationIconByCode } from '@/helpers';
import moment from 'moment';
import ObCurrency from "@/components/obCurrency";
import ObTooltip from 'common-components/src/obComponents/obTooltip';
import obInlineSelect from 'common-components/src/obComponents/obInlineSelect';
moment.locale('ru');
export default {
  name: 'clicarLogchainCard',

  components: {
    ObCurrency,
    ObTooltip,
    obInlineSelect
  },

  logchainIconsMap: {
    'e7519b46-faf4-11e9-8f0b-362b9e155667': 'truck',
    'e7519d9e-faf4-11e9-8f0b-362b9e155667': 'train-sm',
    'e7519ee8-faf4-11e9-8f0b-362b9e155667': 'container',
  },

  props: {
    actualTariff: {
      type: Object,
      default: () => {}
    },
    replaceableServices: {
      type: Array,
      default: () => []
    },
    logchain: {
      type: Object,
      default: () => {}
    },

    showLabel: {
      type: Boolean,
      default: false
    },

    labelText: {
      type: String
    },

    labelIcon: {
      type: String,
      default: 'info'
    },

    labelColor: {
      type: String,
      default: '#10CF96'
    },

    contractNumber: {
      type: String,
    },

    mode: {
      type: String,
      required: true
    },

    primeCost: {
      type: Object
    },

    dataQa: {
      type: String
    }
  },

  data () {
    return {}
  },
  computed: {
    logchainNumber() {
      return (this.logchain.main_data.number && this.logchain.main_data.number !== 'LG00 000 0000') ? this.logchain.main_data.number : null
    },
    limitsTotalAll() {
      const limitsToCheck = this.logchain?.points?.slice(1);
      return limitsToCheck?.every(point => point.limits.length > 0 && point.limits.every(limit => limit.price > 0));
    },
    limitsTotal() {
      const getLimits = (limits, count) => {
        return limits.reduce((acc, item) => {
          return acc + (item.price * count);
        }, 0)
      };

      const val = this.servicePoints.reduce((acc, item) => {
        return acc + getLimits(item.limits, item.count || 1);
      }, 0);

      return val / 100;
    },

    multistopProfit() {
      return this.servicePoints.reduce((acc, item) => {
        return acc + item.limits[0]?.price * 1;
      }, 0);
    },

    startPoint() {
      return this.logchain?.points?.find(item => item.ordinal === 1) || {};
    },

    endPoint() {
      return this.logchain?.points?.find(item => item.ordinal === this.logchain?.points?.length) || {};
    },

    inBetweenPoints() {
      return this.logchain?.points?.filter(point => point.ordinal !== 1 && point.ordinal !== this.logchain?.points?.length);
    },
    servicePoints() {
      const servicePoints = this.inBetweenPoints && this.endPoint ? [...this.inBetweenPoints, this.endPoint] : [];
      if (this.logchain?.main_data.is_multistop && servicePoints.length > 0) {
        const secondPoint = servicePoints.find(point => point.ordinal === 2);
        const lastPoint = servicePoints.find(point => point.ordinal === this.logchain.points.length);
        lastPoint.second_point__resource_title = secondPoint.resource_title;
        lastPoint.second_point__resource_count = secondPoint.resource_count;
      }
      return servicePoints;
    },
    labelStyle () {
      return `background-color: ${this.labelColor};`
    },

    startDate () {
      const dateOptions = {
        month: 'long',
        day: 'numeric'
      };

      const timeOptions = {
        hour: '2-digit',
        minute: '2-digit'
      };

      const weekdayOptions = {
        weekday: 'short'
      };

      const date = new Date(this.logchain?.main_data.eta_start_dt).toLocaleDateString('ru-RU', dateOptions);

      const time = new Date(this.logchain?.main_data.eta_start_dt).toLocaleTimeString('ru-RU', timeOptions);

      const weekday = new Date(this.logchain?.main_data.eta_start_dt).toLocaleDateString('ru-RU', weekdayOptions);
      return `${date}, ${time}(${weekday})`;
    },

    endDate () {
      const dateOptions = {
        month: 'long',
        day: 'numeric'
      };

      const timeOptions = {
        hour: '2-digit',
        minute: '2-digit'
      };

      const weekdayOptions = {
        weekday: 'short'
      };

      const date = new Date(this.logchain?.main_data.eta_end_dt).toLocaleDateString('ru-RU', dateOptions);

      const time = new Date(this.logchain?.main_data.eta_end_dt).toLocaleTimeString('ru-RU', timeOptions);

      const weekday = new Date(this.logchain?.main_data.eta_end_dt).toLocaleDateString('ru-RU', weekdayOptions);
      return `${date}, ${time}(${weekday})`;
    },

    topStartDate() {
      const dateOptions = {
        month: 'long',
        day: 'numeric',
      }

      return new Date(this.logchain?.main_data.eta_start_dt).toLocaleDateString('ru-RU', dateOptions);
    },

    topEndDate() {
      const dateOptions = {
        month: 'long',
        day: 'numeric',
      }
      return new Date(this.logchain?.main_data.eta_end_dt).toLocaleDateString('ru-RU', dateOptions);
    },

    routeLength () {
      return this.logchain.main_data.route_length_in_m ? this.getLength(this.logchain.main_data.route_length_in_m) + 'км' : '0 км'
    },
    routeDuration () {
      return this.logchain.main_data.route_duration_in_sec ? this.getDuration(this.logchain.main_data.route_duration_in_sec) : '0 дней'
    }
  },

  methods: {
    getLocationIconByCode,
    showErrorsInfo() {
      this.$emit('showErrors', this.logchain.errors)
    },
    onChangeService(e) {
      this.$emit('serviceReplaced', e);
    },
    inbetweenPointVat(point) {
      return point.limits.find(item => !item.haveParent)?.price / 100;
    },

    inbetweenPointVatChild(point) {
      return point.limits.find(item => item.haveParent)?.price / 100;
    },

    getLength(value) {
      return Math.ceil(value / 1000);
    },

    getDuration(duration) {
      const fm = [
        Math.floor(duration / (3600 * 24)),
        Math.ceil((duration % (3600 * 24)) / 3600)
      ];
      return fm
        .map((v, i) => {
          if (v) {
            if (i === 0) {
              v = this.plural(v, "день | дня | дней");
            } else if (i === 1) {
              v = this.plural(v, "час | часа | часов");
            } else if (i === 2) {
              v = this.plural(v, "минута| минуты | минут");
            } else if (i === 3) {
              v = this.plural(v, "секунда | секунды | секунд");
            }
            return v;
          }
        })
        .join(" ");
    },

    plural(value, unit) {
      return value + this.declOfNum(value, unit);
    },

    declOfNum(n, string) {
      let titles = string.split("|");
      return titles[
        n % 10 == 1 && n % 100 != 11
          ? 0
          : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
          ? 1
          : 2
      ];
    },

    isGroupReplaceableServices(arr) {
      return arr && arr.length > 6;
    },

    getReplaceableServices(arr) {
      if (this.isGroupReplaceableServices(arr)) {
        const groupes = [...new Set(arr.map(item => item.resourceSubtypeTitle))];
        const data = groupes.map(group => {
          return {
            groupTitle: group,
            items: arr.filter(item => item.resourceSubtypeTitle === group)
          }
        });
        return data;
      } else {
        return arr;
      }
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.logchain-card {
  width: 100%;
  position: relative;
  padding: 25px 30px 30px;
  background-color: $background-white;
  border-radius: 4px;
  box-shadow: 0px 4px 16px rgba(0, 75, 200, 0.2);
}

.logchain-card__header {
  margin-bottom: 33px;
}

.logchain-card__header-info {
  display: flex;
}

.logchain-card__price {
  margin-right: 61px;
  @include font-mixin(30px, 36px, 700, $shale-gray, 0.4px);
  display: flex;
  align-items: center;

  span {
    @include font-mixin(10px, 20px, 400, $gray-slate, 0.4px);
    margin-left: 1em;
  }
}

.logchain-card__dates {
  margin-top: 9px;
  margin-right: 50px;
  @include font-mixin(12px, 16px, 700, $shale-gray, 0.4px);
}

.logchain-card__route-info {
  display: flex;
  align-items: center;
  @include font-mixin(12px, 16px, 400, $color-grey-span, 0.4px);

  .icon {
    margin-right: 6px;
    font-size: 15px;
    color: $cobalt;
  }
}

.logchain-card__contractor {
  display: flex;
  align-items: center;
  margin-left: auto;
  @include font-mixin(12px, 16px, 400, $color-grey-span, 0.4px);

  .icon {
    margin: 0 6px;
    font-size: 15px;
    color: $cobalt;
  }

  span {
    color: $color-text-base;
  }
}

.logchain-card__header-details {
  @include font-mixin(10px, 16px, 400, $color-text-base, 0.4px);

  // p {
  //   @include font-mixin(10px, 16px, 400, $color-text-base, 0.4px);
  // }

  // p + p {
  //   margin-top: 0;
  // }

  // p:first-child {
  //   margin-right: 21px;
  // }

  a {
    color: $cobalt;
    text-decoration: none;
  }
}

.logchain-card__header-contract {
  margin: 5px 0;

  span + span {
    margin-left: 20px;
  }
}

.loghain-card__header-tariff {
  margin-top: 5px;

  span {
    color: $color-error;

    .icon {
      margin-right: 2px;
    }
  }

  .vat-percent {
    margin-left: 10px;
    color: $Green-700;
  }
}

.loghain-card__header-vat {
  span {
    color: $color-error;

    .icon {
      margin-right: 2px;
    }
  }
}

.logchain-card__content {
  position: relative;
}

.logchain-card__line {
  position: relative;
  height: 2px;
  border-top: 2px dotted $cornflower-craiola;
}

.start-icon {
  position: absolute;
  left: -13px;
  top: -32px;
  // width: 15px;
  height: 30px;
  display: flex;
  font-size: 40px;

  .icon + .icon {
    margin-left: -10px;
  }
}

.end-icon {
  position: absolute;
  right: -12px;
  top: -32px;
  // width: 15px;
  display: flex;
  flex-direction: row-reverse;
  height: 30px;
  font-size: 40px;

  .icon + .icon {
    margin-right: -10px;
  }
}

.logchain-card__points {
  display: flex;
  justify-content: space-between;
  width: 100%;
  margin-top: 8px;
  @include font-mixin(10px, 12px, 600, $shale-gray, 0.6px, uppercase);

  i {
    margin-bottom: 5px;
    font-size: 17px;
    color: $color-grey-border;
  }
}

.logchain-card__point {
  position: relative;
  display: flex;
  flex-grow: 1;
  flex-direction: column;
  max-width: 130px;
  align-items: center;
  text-align: center;
  padding: 0 10px;

  &:after {
    content: "";
    width: 6px;
    height: 6px;
    background: #b0c6e7;
    position: absolute;
    top: -12px;
    left: 50%;
    margin-left: -3px;
    border-radius: 50%;
  }

  span {
   @include font-mixin(12px, 16px, 400, $shale-gray, 0.6px);
   white-space: nowrap;
  }
}

.logchain-card__point-icons {
  position: absolute;
  top: -39px;

  i {
    font-size: 40px;
  }

  i + i {
    margin-left: -10px;
  }

  span {
    font-family: 'icomoon' !important;
    font-size: 40px;
    line-height: 1;
  }
}

.logchain-card__point--start {
  align-items: flex-start;
  left: -8px;
  text-align: left;

  &:after {
    display: none;
    margin-left: 0;
    left: 0;
  }
}

.logchain-card__point--end {
  align-items: flex-end;
  right: -8px;
  text-align: right;

  &:after {
    display: none;
    margin-left: 0;
    left: auto;
    right: 0;
  }
}

.logchain-card__inbetween {
  position: absolute;
  width: calc(100% - 60px);
  height: 97px;
  left: 30px;
  top: -32px;
  display: flex;
}

.logchain-card__inbetween-point {
  display: flex;
  flex-grow: 1;
  justify-content: center;

  &--error {
    .logchain-card__inbetween-label {
      color: $color-error;
    }
  }
}

.logchain-card__inbetween-point-info {
  position: relative;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  i {
    position: absolute;
    left: 50%;
    top: 4px;
    transform: translateX(-50%);
    color: $color-grey-span;
    font-size: 19px;
    font-weight: bold;

    &:last-child {
      top: auto;
      bottom: 0;
    }
  }

  .container {
    width: auto;
  }
}

.logchain-card__inbetween-label {
  height: 18px;
  position: absolute;
  top: 25px;
  white-space: nowrap;
  display: flex;
  margin: 0 0 7px;
  background: #fff;
  @include font-mixin(10px, 10px, 400, $color-text-base, 0.2px);
  z-index: 1;

  .count {
    position: relative;
    z-index: 2;
    display: flex;
    align-items: center;
    height: 18px;
    padding: 0 5px;
    margin-right: -14px;
    border-radius: 90px;
    border: 1px solid $color-grey-border;
    background-color: #fff;
    @include font-mixin(11px, 10px, 400, $color-text-base, 0.4px);
  }

  .title {
    position: relative;
    z-index: 1;
    display: flex;
    align-items: center;
    height: 18px;
    padding: 0 5px 0 19px;
    border: 1px solid $color-grey-border;
    border-radius: 5px;
  }

  &::v-deep {
    .ob-inline-select {
      margin-right: 0;
      height: 18px;
      padding: 0 5px 0 19px;
      border: 1px solid $color-grey-border;
      border-radius: 5px;
    }
  }
}

.logchain-card__label {
  padding: 0 10px;
  position: absolute;
  top: 1px;
  right: 1px;
  display: flex;
  align-items: center;
  height: 24px;
  @include font-mixin(12px, 14px, 400, $obCardPath-label_header_font_color, 0.4px);
  border-radius: 4px;

  .icon {
    margin-right: 7px;
    font-size: 16px;
    color: $obCardPath-label_header_font_color;
  }
}

.logchain-card__container {
  position: absolute;
  top: 0;
  left: 0;
  height: 18px;
  display: flex;
  align-items: center;
  padding: 0 5px 0 25px;
  background-color: $color-white-lilac;
  border: 1px solid $color-grey-border;
  border-radius: 5px;
  @include font-mixin(11px, 20px, 400, $color-text-base, 0.4px);

  span {
    margin-left: -28px;
    margin-right: 3px;
    width: 23px;
    height: 18px;
    border: 1px solid $color-grey-border;
    border-radius: 9px;
    display: flex;
    align-items: center;
    justify-content: center;
    @include font-mixin(10px, 12px, 400, $color-text-base, -0.02em);
  }
}

.logchain-card__inbetween-vat {
  position: absolute;
  top: 50px;
  white-space: nowrap;
}

.vat-parent {
  @include font-mixin(10px, 10px, 400, #00A6F5, 0.4px);
}

.vat-child {
  margin-top: 5px;
  @include font-mixin(10px, 10px, 400, #00496C, 0.4px);
}

.error {
  color: $color-error;
}

.logchain-card__bottom-outer,
.logchain-card__top-outer {
  display: flex;
  justify-content: center;
  position: absolute;
  width: 100%;
  left: 0;
}

.logchain-card__bottom-outer {
  bottom: 0;
}

.logchain-card__top-outer {
  top: 0;
}

.logchain-card__info-message {
  background-color: $color-white-lilac;
  border: 1px solid $color-grey-border;
  border-radius: 4px;
  font-size: 10px;
  padding: 4px 8px;
}

.logchain-card__errors {
  display: flex;
  align-items: center;
  padding: 0 18px;
  height: 64px;
  color: $color-text-base;
  border-left: 6px solid $diamond-orange-yellow;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);

  .icon {
    margin-right: 20px;
    color: $diamond-orange-yellow;
    font-size: 24px;
  }

  span {
    color: $color-blue-smalt;
  }
}
</style>
<style>
.replaceablePopper {
  width: 352px;
}
</style>